import unit4.collectionsLib.Node;
/**
 *   : 
 *   
 * @author  , '  
 * @version 14/5/2007
 */
public class Vector<T> 
{
	private Node<T> first;
	private Node<T> last;
	private int numValues;

	public Vector() 
	{
		this.first = null;
		this.last = null;
		this.numValues = 0;
	}
	
	public void add(T x)
	{
		Node<T> node = new Node<T>(x);
		
		if(this.first==null)
			this.first = node;
		else
			this.last.setNext(node);
		this.last = node;
		
		this.numValues++;
	}
	
	public void del(int place)
	{
		if(place==1)
		{ 
			if(this.last==this.first)
				this.last = null;
			this.first = this.first.getNext();
		}
		else
		{
			Node<T> pos = this.first;
			
			for(int i=1; i<=place-2; i++) 
				pos = pos.getNext();
			
			if(pos.getNext()==this.last)
				this.last = pos;
			pos.setNext(pos.getNext().getNext());
		}
	
		this.numValues--;
	}
	
	public T get(int place)
	{
		Node<T> pos = this.first;
		
		for(int i=1; i<place; i++) 
			pos = pos.getNext();
		
		return(pos.getInfo());
	}
	
	public void set(int place, T x)
	{
		Node<T> pos = this.first;
		
		for(int i=1; i<place; i++) 
			pos = pos.getNext();
		
		pos.setInfo(x);
	}

	public int length()
	{
		return(this.numValues);
	}
	
	public String toString()
	{
		String str = "";
		
		if(this.first!=null)
		{
			Node<T> pos = this.first;
		
			while(pos!=this.last)
			{
				str = str + pos.getInfo() + ",";
				pos = pos.getNext();
			}
			str = str + this.last.getInfo();
		}
		return(str);
	}
}
